/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   Modulo para utilizar o Serv. MTA SCEO com Mysql                     
   Programado por Lucas Priori                                         
   Versao: 1.2.2                                                       
                                                                       
   Compilar:                                                           
   gcc sceo_mysql.c -o sceo_mysql -lmysqlclient -lcrypt                
                                                                       
  ******************************************************************   
  sceo_mysql e' um modulo externo que da suporte a consultas Mysql     
  para o servidor MTA Sceo                                             
  Copyright (C) 2007  Lucas Priori                                     
                                                                       
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or    
  (at your option) any later version.                                  
                                                                       
  This program is distributed in the hope that it will be useful,      
  but WITHOUT ANY WARRANTY; without even the implied warranty of       
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
  GNU General Public License for more details.                         
                                                                       
  You should have received a copy of the GNU General Public License    
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<string.h>
#include<mysql/mysql.h>
#include<mysql/errmsg.h>
#include<sched.h>
#include<unistd.h>
#include<crypt.h>

#define TAM_buffer 2048
#define VERSAO "1.2.2"
#define TAM_cmd 256
#define TAM_cmd_sql 512
#define ALIAS_LIMIT 10
#define MAILDIRSIZE 1
#define MAILBOX 2
#define MAX_ptr_quota 5

char buffer[TAM_buffer+1];
char linha[TAM_buffer+1];
char maildirsize=1;
char quota_type=MAILDIRSIZE;

//---------------------------------------------------
//Funcao para comparar duas strings desconciderando  
//a diferena entre maisculas e minsculas          
//Retornos:                                          
//0 = strings so iguais                             
//1 = strings so diferentes                         
int cmp_str(char *string1,char *string2,int num_bytes){
 if(!num_bytes){
  if(*string1==*string2)return 0;
  return 1;
 }
 int ret_val=0;
 asm(
  "movl %0,%%edi           \n"
  "movl %1,%%esi           \n"
 "CMP_STR_proxbyte:        \n"
  "movb (%%esi),%%al       \n"
  "cmpb (%%edi),%%al       \n"
  "jne  CMP_STR_trocar     \n"
 "CMP_STR_incr:            \n"
  "incl %%esi              \n"
  "incl %%edi              \n"
  "loop CMP_STR_proxbyte   \n"
  "jmp  CMP_STR_term       \n"
 "CMP_STR_trocar:          \n"
  "xorb $32,%%al           \n"
  "cmpb (%%edi),%%al       \n"
  "je   CMP_STR_incr       \n"
 "CMP_STR_term:            \n"
  "testw %%cx,%%cx         \n"
  "jz   CMP_STR_fim        \n"
  "movw $1,%%cx            \n"
 "CMP_STR_fim:             \n"
  "movw  %%cx,%3           \n"
  :
  :"m"(string1),"m"(string2),"c"(num_bytes),"m"(ret_val)
  :"edi","esi","eax"
 );
 return ret_val;
}


//---------------------------------------------------
//Retorna o tamanho atual da caixa postal de um      
//usuario                                            
void ret_quota(char *home,char *maildir,unsigned long long int *tam_cxp,unsigned long long int *num_msgs){
 char linha_quota[100]={0};
 char prim_linha=1;
 int arq_maildir;
 unsigned int b_lidos=0;
 unsigned int cont1=0;
 unsigned int cont2=0;
 unsigned int cont3=0;
 int temp=0;
 long long int tam=0;
 long long int num=0;
 long long int ttotal=0;
 long long int ntotal=0;
 
 
 if(!home || !maildir)return;   // Impossivel medir o tamanho sem saber o caminho
 snprintf(linha,sizeof(linha),"%s/%s",home,maildir);
 /* Metodo via maildirsize */
 switch(quota_type){
 case MAILDIRSIZE:
  strcat(linha,"/maildirsize\0");
  arq_maildir=open(linha,O_RDWR | O_CREAT,0666);
  if(arq_maildir<0)return;      // Arquivo maildirsize nao existe
  // Travando o arquivo
  while(lockf(arq_maildir,F_TLOCK,0)&& cont3<100){
   cont3++;
   sched_yield();        // Passar a vez para outro processo. Aguardando at o arquivo liberar
  }
  do{
   b_lidos=read(arq_maildir,buffer,TAM_buffer);
   buffer[b_lidos]=0;
   for(cont1=0;cont1<b_lidos;cont1++){
   	linha[cont2]=0;
    if(buffer[cont1]==10){
    	if(prim_linha){
     	// Primeira linha 
     	strncpy(linha_quota,linha,sizeof(linha_quota));
     	prim_linha=0;
     }else {
     	if(cont2>3){
       temp=sscanf(linha,"%lld %lld",&tam,&num);
       if(temp==2){
        ttotal+=tam;
        ntotal+=num;
        if(ttotal<0)ttotal=0;
        if(ntotal<0)ntotal=0;
       }
      }
     }
     cont2=0;
    }else if(buffer[cont1]!=13){
     linha[cont2]=buffer[cont1];
     cont2++;
    }
   }
  }while(b_lidos==TAM_buffer);
  if(cont3<100){
   // Arquivo travado. Vamos alterar os dados dele para ficar menor
   b_lidos=sprintf(buffer,"%s\n%12lld %12lld\n",linha_quota,ttotal,ntotal);
   lseek(arq_maildir,0,0);
   write(arq_maildir,buffer,b_lidos);
   close(arq_maildir);
   snprintf(linha,sizeof(linha),"%s/%s/maildirsize",home,maildir);
   truncate(linha,b_lidos);
  }else close(arq_maildir);
  *tam_cxp=ttotal;
  *num_msgs=ntotal;
  return;
  break;
 case MAILBOX:
  // Sem suporte a MAILBOX no momento
  break;
 }
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
int main(int argc,char *argv[]){
 MYSQL *mysql = NULL;
 MYSQL *mysqlt = NULL;
 MYSQL_RES *myres; 
 MYSQL_ROW myreg;
 FILE *arq_conf;
 /* --- DADOS DE CONEXAO --- */
 char host[100]={0};
 char db[100]={0};
 char user[100]={0};
 char pass[100]={0};
 char user_table[100]={0};
 char user_login_field[100]={0};
 char user_pass_field[100]={0};
 char user_home_field[100]={0};
 char user_maildir_field[100]={0};
 char user_quota_field[100]={0};
 char user_pass_type[50]={0};
 char domain_table[100]={0};
 char domain_field[100]={0};
 char alias_table[100]={0};
 char alias_field[100]={0};
 char alias_rcpt_field[100]={0};
 char where_clause[100]={0};
 char quota_type=0;
 char no_connect_stop=1;
 char tentativa_cnx=0;
 //---
 char byte=0;
 char cmd[TAM_cmd+1];
 char cmd_sql[TAM_cmd_sql+1];
 char *ptr=cmd;
 char *ptr_aux=cmd;
 char *ptr_aux1;
 char *ptr_quota[MAX_ptr_quota];
 unsigned int cont_ptr_quota=0;
 unsigned int alias_cont=0;
 unsigned int b_lidos=0;
 unsigned int cont1=0;
 unsigned int cont2=0;
 long long int bd_ttotal=0;
 long long int bd_ntotal=0;
 long long int ttotal=0;
 long long int ntotal=0;
 
 
 setbuf(stdout,NULL);
 /* -- Lendo arquivo de configurao -- */
 if(argc<2){
  printf("-ERROR Arquivo de configuracao nao especificado\n");
  return 1;
 }
 arq_conf=fopen(argv[1],"rb");
 if(!arq_conf){
  printf("-ERROR Nao foi possivel abrir o arquivo de configuracao [%s]\n",argv[1]);
  return 1;
 }
 cont2=0;
 while(!feof(arq_conf)){
  b_lidos=fread(&buffer,1,TAM_buffer,arq_conf);
  for(cont1=0;cont1<b_lidos;cont1++){
   if(buffer[cont1]==10){
    linha[cont2]=0;
    if(!cmp_str(linha,"host=",5)){
     /* -- HOST -- */
     ptr=&linha[5];
     while(*ptr==' ')ptr++;
     strncpy(host,ptr,sizeof(host));
    }else if(!cmp_str(linha,"db=",3)){
     /* -- DB -- */
     ptr=&linha[3];
     while(*ptr==' ')ptr++;
     strncpy(db,ptr,sizeof(db));
    }else if(!cmp_str(linha,"user=",5)){
     /* -- USER -- */
     ptr=&linha[5];
     while(*ptr==' ')ptr++;
     strncpy(user,ptr,sizeof(user));
    }else if(!cmp_str(linha,"pass=",5)){
     /* -- PASS -- */
     ptr=&linha[5];
     while(*ptr==' ')ptr++;
     strncpy(pass,ptr,sizeof(pass));
    }else if(!cmp_str(linha,"user_table=",11)){
     /* -- USER_TABLE -- */
     ptr=&linha[11];
     while(*ptr==' ')ptr++;
     strncpy(user_table,ptr,sizeof(user_table));
    }else if(!cmp_str(linha,"user_login_field=",17)){
     /* -- USER_LOGIN_FIELD -- */
     ptr=&linha[17];
     while(*ptr==' ')ptr++;
     strncpy(user_login_field,ptr,sizeof(user_login_field));
    }else if(!cmp_str(linha,"user_pass_field=",16)){
     /* -- USER_PASS_FIELD -- */
     ptr=&linha[16];
     while(*ptr==' ')ptr++;
     strncpy(user_pass_field,ptr,sizeof(user_pass_field));
    }else if(!cmp_str(linha,"user_home_field=",16)){
     /* -- USER_HOME_FIELD -- */
     ptr=&linha[16];
     while(*ptr==' ')ptr++;
     strncpy(user_home_field,ptr,sizeof(user_home_field));
    }else if(!cmp_str(linha,"user_maildir_field=",19)){
     /* -- USER_MALDIR_FIELD -- */
     ptr=&linha[19];
     while(*ptr==' ')ptr++;
     strncpy(user_maildir_field,ptr,sizeof(user_maildir_field));
    }else if(!cmp_str(linha,"user_quota_field=",17)){
     /* -- USER_PASS_FIELD -- */
     ptr=&linha[17];
     while(*ptr==' ')ptr++;
     strncpy(user_quota_field,ptr,sizeof(user_quota_field));
    }else if(!cmp_str(linha,"user_pass_type=",15)){
     /* -- USER_PASS_TYPE -- */
     ptr=&linha[16];
     while(*ptr==' ')ptr++;
     strncpy(user_pass_type,ptr,sizeof(user_pass_type));
    }else if(!cmp_str(linha,"domain_table=",13)){
     /* -- DOMAIN_TABLE -- */
     ptr=&linha[13];
     while(*ptr==' ')ptr++;
     strncpy(domain_table,ptr,sizeof(domain_table));
    }else if(!cmp_str(linha,"domain_field=",13)){
     /* -- DOMAIN_FIELD -- */
     ptr=&linha[13];
     while(*ptr==' ')ptr++;
     strncpy(domain_field,ptr,sizeof(domain_field));
    }else if(!cmp_str(linha,"alias_table=",12)){
     /* -- ALIAS_TABLE -- */
     ptr=&linha[12];
     while(*ptr==' ')ptr++;
     strncpy(alias_table,ptr,sizeof(alias_table));
    }else if(!cmp_str(linha,"alias_field=",12)){
     /* -- ALIAS_FIELD -- */
     ptr=&linha[12];
     while(*ptr==' ')ptr++;
     strncpy(alias_field,ptr,sizeof(alias_field));
    }else if(!cmp_str(linha,"alias_rcpt_field=",17)){
     /* -- ALIAS_RCPT_FIELD -- */
     ptr=&linha[17];
     while(*ptr==' ')ptr++;
     strncpy(alias_rcpt_field,ptr,sizeof(alias_rcpt_field));
    }else if(!cmp_str(linha,"where_clause=",13)){
     /* -- WHERE CLAUSE -- */
     ptr=&linha[13];
     while(*ptr==' ')ptr++;
     snprintf(where_clause,sizeof(where_clause)-1,"AND %s",ptr);
    }else if(!cmp_str(linha,"quota_type=",11)){
     /* -- QUOTA_TYPE -- */
     ptr=&linha[11];
     while(*ptr==' ')ptr++;
     if(!cmp_str(ptr,"maildirsize\0",12)){
      // MAILDIRSIZE
      quota_type=1;
     }else {
      printf("-ERROR quota_type invalido: [%s]\n",ptr);
      return 1;
     }
    }else if(!cmp_str(linha,"no_connect_stop=",16)){
     /* -- NO_CONNECT_STOP --*/
     ptr=&linha[16];
     while(*ptr==' ')ptr++;
     if(*ptr=='0')no_connect_stop=0;
    }
    cont2=0;
   }else if(buffer[cont1]!=13){
    linha[cont2]=buffer[cont1];
    cont2++;
   }
  }
 }
 
 if(!host[0] || !db[0] || !user[0] || !pass[0] || !user_table[0] || !user_login_field[0] || !user_pass_field[0] || !user_home_field[0] || !user_maildir_field[0] || !user_pass_type[0] || !user_quota_field[0] || !domain_table[0] || !domain_field[0] || !alias_table[0] || !alias_field[0] || !alias_rcpt_field[0]){
  printf("Faltam os seguintes parametros no arquivo de configuracao:\n");
  if(!host[0])printf(" host=\n");
  if(!db[0])printf(" db=\n");
  if(!user[0])printf(" user=\n");
  if(!pass[0])printf(" pass=\n");
  if(!user_table[0])printf(" user_table=\n");
  if(!user_login_field[0])printf(" user_login_field=\n");
  if(!user_pass_field[0])printf(" user_pass_field=\n");
  if(!user_home_field[0])printf(" user_home_field=\n");
  if(!user_maildir_field[0])printf(" user_maildir_field=\n");
  if(!user_quota_field[0])printf(" user_quota_field=\n");
  if(!user_pass_type[0])printf(" user_pass_type=\n");
  if(!domain_table[0])printf(" domain_table=\n");
  if(!domain_field[0])printf(" domain_field=\n");
  if(!alias_table[0])printf(" alias_table=\n");
  if(!alias_field[0])printf(" alias_field=\n");
  if(!alias_rcpt_field[0])printf(" alias_rcpt_field=\n");
  printf("\n");
  return 1;
 }
 mysql = mysql_init(NULL);
 if(!mysql){
  printf("-ERROR Nao foi possivel iniciar as funes do Mysql\n\n");
  return 1;
 }
 // --- Conectando ao banco de dados ---
 mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
 cont1=0;
 if(mysql==mysqlt)printf("+OK SCEO_Mysql v %s Conectado\n",VERSAO);
 else printf("+OK SCEO_Mysql v %s Nao conectado\n",VERSAO);
 while((byte=fgetc(stdin))!=EOF){
  cmd[cont1]=byte;
  cont1++;
  if(cont1>=TAM_cmd){
   printf("!ERROR Comando muito grande\n");
   cont1=0;
   cmd[0]=0;
  }else {
   if(byte==10){
    cont1--;
    cmd[cont1]=0;
    tentativa_cnx=0;
    // -- Interpretando comando --
    if(!strncmp(cmd,"local ",6)){
     //-- << CMD local >> --
     ptr=&cmd[6];
     snprintf(cmd_sql,TAM_cmd_sql,"SELECT * FROM %s WHERE %s='%s'",domain_table,domain_field,ptr);
     CMD_local:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      if((myreg=mysql_fetch_row(myres))!=NULL)printf("+OK\n");
      else printf("-Nao local\n");
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_local;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"user ",5)){
     //-- << CMD user >> --
     ptr=&cmd[5];
     snprintf(cmd_sql,TAM_cmd_sql,"SELECT * FROM %s WHERE %s='%s' %s",user_table,user_login_field,ptr,where_clause);
     CMD_user:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      if((myreg=mysql_fetch_row(myres))!=NULL)printf("+OK\n");
      else printf("-Email inexistente\n");
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_user;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"auth ",5)){
     //-- << CMD auth >> --
     ptr=&cmd[5];
     ptr_aux=strchr(ptr,' ');
     if(ptr_aux!=NULL){
      ptr_aux[0]=0;
      ptr_aux++;        // ptr_aux agora esta apontando para a senha
      snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s FROM %s WHERE %s='%s' %s",user_pass_field,user_table,user_login_field,ptr,where_clause);
      CMD_auth:
      if(!mysql_query(mysql,cmd_sql)){
       myres=mysql_store_result(mysql);
       if((myreg=mysql_fetch_row(myres))!=NULL){
        if(!cmp_str(user_pass_type,"crypt",strlen(user_pass_type))){
         /* --- Modo de senha criptografada --- */
         if(!strcmp((char *)crypt(ptr_aux,myreg[0]),myreg[0]))printf("+OK\n");
         else printf("-Senha invalida\n");
        }else {
         /* --- Modo de senha texto --- */
         if(!strcmp(ptr_aux,myreg[0]))printf("+OK\n");
         else printf("-Senha invalida\n");
        }
       }else printf("-Usuario inexistente\n");
       mysql_free_result(myres);
      }else {
       if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
        // Sem conexao
        tentativa_cnx=1;
        mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
        if(mysql==mysqlt)goto CMD_auth;
       }
       printf("!ERROR Erro executando: [%s]\n",cmd_sql);
      }
     }else {
      printf("!ERROR Parametro invalido. Ex: auth usuario senha\n");
     }
    }else if(!strncmp(cmd,"alias ",6)){
     //-- << CMD alias >> --
     ptr=&cmd[6];
     ptr_aux=strchr(ptr,' ');
     if(ptr_aux!=NULL){
      *ptr_aux=0;
      ptr_aux++; 
     }else ptr_aux="0\0";
     Nova_busca_alias:
     snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s FROM %s WHERE %s='%s' LIMIT %s,%d",alias_rcpt_field,alias_table,alias_field,ptr,ptr_aux,ALIAS_LIMIT);
     alias_cont=0;
     CMD_alias:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      buffer[0]=0;
      while((myreg=mysql_fetch_row(myres))!=NULL){
       sprintf(linha,"+OK %s\n",myreg[0]);                   // Precisamos acumular os alias em uma variavel 
       strcat(buffer,linha);                                 // e envia-los ao Sceo (printf)de uma s vez    
       alias_cont++;
      }
      if(!alias_cont && *ptr!='@'){
      	// Nada encontrado. Vamos procurar por conta PEGA-TUDO
      	ptr=strchr(ptr,'@');
      	if(ptr)goto Nova_busca_alias;
      }
      if(alias_cont<ALIAS_LIMIT)strcat(buffer,"+OK\n");      //Caso retorne ALIAS_LIMIT resultados, no mostrar o +OK\n
      printf("%s",buffer);
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_alias;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"quota ",6) || !strncmp(cmd,"qtest ",6)){
     //-- << CMD quota >> --
     ptr=&cmd[6];
     snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s, %s, %s FROM %s WHERE %s='%s'",user_quota_field,user_home_field,user_maildir_field,user_table,user_login_field,ptr);
     CMD_quota:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      if((myreg=mysql_fetch_row(myres))!=NULL){
       if(cmd[1]=='t'){
        // Testando o atual tamanho da caixa postal
        if((myreg[0][0]=='0' && !myreg[0][1]) || (!myreg[0][0]))printf("+OK Free\n");
        else {
        	// Lendo as inf. retornadas pelo BD 
        	cont_ptr_quota=0;
        	bd_ttotal=0;
        	bd_ntotal=0;
        	strncpy(linha,myreg[0],sizeof(linha)-1);
        	ptr_aux1=linha;
        	while(*ptr_aux1==' ')ptr_aux1++;         // Tirando espacos na frente da informacao, se tiver
        	ptr_quota[cont_ptr_quota]=ptr_aux1;
        	while(*ptr_aux1){
        		// Separando dados do campo Quota do BD 
        		if(*ptr_aux1==' ')*ptr_aux1=0;
        		else if(*ptr_aux1==','){
      				 *ptr_aux1=0;
      				 ptr_aux1++;
      				 while(*ptr_aux1==' ')ptr_aux1++;
       			 cont_ptr_quota++;
       			 ptr_quota[cont_ptr_quota]=ptr_aux1;
        		}
        		ptr_aux1++;
        	}
        	for(cont2=0;cont2<=cont_ptr_quota;cont2++){
        		// Lendo valores
        		if(strchr(ptr_quota[cont2],'S')){
        			// Quota de tamanho
        			if(!bd_ttotal)bd_ttotal=atoll(ptr_quota[cont2]);
        		}else if(strchr(ptr_quota[cont2],'C')){
        			// Quota por numero de msgs
        			if(!bd_ntotal)bd_ntotal=atoll(ptr_quota[cont2]);
        		}else {
        			// Por numero do campo
        			if(!cont2)bd_ttotal=atoll(ptr_quota[cont2]);
        			else if(cont2==1)bd_ntotal=atoll(ptr_quota[cont2]);
        		}
        	}
        	ret_quota(myreg[1],myreg[2],&ttotal,&ntotal);
         if((bd_ttotal && ttotal>=bd_ttotal) || (bd_ntotal && ntotal>=bd_ntotal))printf("+OK Exceeded\n");
         else printf("+OK Free\n");
        }
       }else printf("+OK %s\n",myreg[0]);
      }else printf("-Email inexistente\n");
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_quota;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else {
     // -- Comando desconhecido --
     printf("!ERROR Comando desconhecido\n");
    }
    cont1=0;
    cmd[0]=0;
   }
  }
 }
 return 0;
}

